function ictkm_set_path()
% -------------------------------------------------------------------------
% Set MATLAB's path for running the toolbox.
% -------------------------------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compressed Dictionary Learning Toolbox
% Copyright (C) Flavio Teixeira 2018
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, 
% Boston, MA  02110-1301, USA.    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
addpath('algorithm/');

addpath('data/');

addpath('docs/');
addpath('docs/html/');

addpath('example/');

addpath('init/');

addpath('simulation/');
addpath('simulation/results/');
addpath('simulation/compute_cluster/');
addpath('simulation/compute_cluster/mat_files/');

addpath('utils/');
addpath('utils/pitch_detection');
addpath('utils/phase_vocoder');
addpath('utils/matlab2tikz');
addpath('utils/line_fewer_markers_v4');