#!/bin/bash


NUM_ITERATIONS=3
NUM_SIGNAL_TYPES=2
NUM_JL_TRANSFORM_TYPES=5
NUM_GEN_DICO_TYPES=3

#DIM_RATIO_ARRAY_SIZE=4
#declare -a DIM_RATIO_ARRAY=(-1 32 64 128 256)
DIM_RATIO_ARRAY_SIZE=1
declare -a DIM_RATIO_ARRAY=(-1 32)

INTRINSIC_DIM=1024
DIM_REDUCTION_ARRAY_SIZE=7
declare -a DIM_REDUCTION_ARRAY=(-1 0.9 0.65 0.4 0.3 0.2 0.15 0.1)


i_jl_transf=1
while [ ${i_jl_transf} -le ${NUM_JL_TRANSFORM_TYPES} ]; 
do
	if [ “${i_jl_transf}” == “1” ]; then
		PARTIAL_FOURIER_EMBEDDDING=1
		PARTIAL_DCT_EMBEDDING=0
		PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING=0
		PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING=0
	elif [ “${i_jl_transf}” == “2” ]; then
		PARTIAL_FOURIER_EMBEDDDING=0
		PARTIAL_DCT_EMBEDDING=1
		PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING=0
		PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING=0
	elif [ “${i_jl_transf}” == “3” ]; then
		PARTIAL_FOURIER_EMBEDDDING=0
		PARTIAL_DCT_EMBEDDING=0
		PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING=1
		PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING=0
	elif [ “${i_jl_transf}” == “4” ]; then
		PARTIAL_FOURIER_EMBEDDDING=0
		PARTIAL_DCT_EMBEDDING=0
		PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING=0
		PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING=1
	elif [ “${i_jl_transf}” == “5” ]; then
		PARTIAL_FOURIER_EMBEDDDING=0
		PARTIAL_DCT_EMBEDDING=0
		PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING=0
		PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING=0
	fi            

	i_signal_type=1
	while [ ${i_signal_type} -le ${NUM_SIGNAL_TYPES} ]; 
	do     					  
	if [ “${i_signal_type}” == “1” ]; then
		NOISELESS_SIGNAL=0
	elif [ “${i_signal_type}” == “2” ]; then
		NOISELESS_SIGNAL=1

		i_signal_type=$((${i_signal_type}+1))
		continue
	fi

	i_dico_type=1
	while [ ${i_dico_type} -le ${NUM_GEN_DICO_TYPES} ]; 
	do
		if [ “${i_dico_type}” == “1” ]; then
			ORIG_DICO_DIRACDCT=1
			ORIG_DICO_HAARDCT=0
			ORIG_DICO_RANDOM=0

			i_dico_type=$((${i_dico_type}+1))
			continue
		elif [ “${i_dico_type}” == “2” ]; then
			ORIG_DICO_DIRACDCT=0
			ORIG_DICO_HAARDCT=1
			ORIG_DICO_RANDOM=0

			i_dico_type=$((${i_dico_type}+1))
			continue
		elif [ “${i_dico_type}” == “3” ]; then
			ORIG_DICO_DIRACDCT=0
			ORIG_DICO_HAARDCT=0
			ORIG_DICO_RANDOM=1
		fi																						

		i_dim_ratio=1
		while [ ${i_dim_ratio} -le ${DIM_RATIO_ARRAY_SIZE} ]; 
		do											
							
		DIM_RATIO=${DIM_RATIO_ARRAY[$i_dim_ratio]}
					
		if [ “${i_jl_transf}” == “5” ]; then
			DIM_REDUCTION=0						
						
			./ictkm_benchmark_simulation ${INTRINSIC_DIM} ${DIM_RATIO} ${DIM_REDUCTION} ${NOISELESS_SIGNAL} ${ORIG_DICO_DIRACDCT} ${ORIG_DICO_HAARDCT} ${ORIG_DICO_RANDOM} ${NUM_ITERATIONS} ${PARTIAL_FOURIER_EMBEDDDING} ${PARTIAL_DCT_EMBEDDING} ${PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING} ${PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING}
						
			#echo "INTRINSIC_DIM=${INTRINSIC_DIM} DIM_RATIO=${DIM_RATIO} DIM_REDUCTION=${DIM_REDUCTION} NOISELESS_SIGNAL=${NOISELESS_SIGNAL} ORIG_DICO_DIRACDCT=${ORIG_DICO_DIRACDCT} ORIG_DICO_HAARDCT=${ORIG_DICO_HAARDCT} ORIG_DICO_RANDOM=${ORIG_DICO_RANDOM} NUM_ITERATIONS=${NUM_ITERATIONS} PARTIAL_FOURIER=${PARTIAL_FOURIER_EMBEDDDING} PARTIAL_DCT=${PARTIAL_DCT_EMBEDDING} PARTIAL_GAUSSIAN=${PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING} PARTIAL_RADEMACHER=${PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING}"
		else
			i_dim_reduction=1
			while [ ${i_dim_reduction} -le ${DIM_REDUCTION_ARRAY_SIZE} ]; 
			do
				DIM_REDUCTION=${DIM_REDUCTION_ARRAY[$i_dim_reduction]}						
						
				./ictkm_benchmark_simulation ${INTRINSIC_DIM} ${DIM_RATIO} ${DIM_REDUCTION} ${NOISELESS_SIGNAL} ${ORIG_DICO_DIRACDCT} ${ORIG_DICO_HAARDCT} ${ORIG_DICO_RANDOM} ${NUM_ITERATIONS} ${PARTIAL_FOURIER_EMBEDDDING} ${PARTIAL_DCT_EMBEDDING} ${PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING} ${PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING}
						
				#echo "INTRINSIC_DIM=${INTRINSIC_DIM} DIM_RATIO=${DIM_RATIO} DIM_REDUCTION=${DIM_REDUCTION} NOISELESS_SIGNAL=${NOISELESS_SIGNAL} ORIG_DICO_DIRACDCT=${ORIG_DICO_DIRACDCT} ORIG_DICO_HAARDCT=${ORIG_DICO_HAARDCT} ORIG_DICO_RANDOM=${ORIG_DICO_RANDOM} NUM_ITERATIONS=${NUM_ITERATIONS} PARTIAL_FOURIER=${PARTIAL_FOURIER_EMBEDDDING} PARTIAL_DCT=${PARTIAL_DCT_EMBEDDING} PARTIAL_GAUSSIAN=${PARTIAL_CIRCULANT_GAUSSIAN_EMBEDDING} PARTIAL_RADEMACHER=${PARTIAL_CIRCULANT_RADEMACHER_EMBEDDING}"
						
				i_dim_reduction=$((${i_dim_reduction}+1))
			done
		fi
					
						
		i_dim_ratio=$((${i_dim_ratio}+1))
	done
	i_dico_type=$((${i_dico_type}+1))
done
i_signal_type=$((${i_signal_type}+1))						
done
i_jl_transf=$((${i_jl_transf}+1))
done
