#!/bin/bash

# ==========================================================================
# Script to submit jobs to the compute cluster:
# job_ictkm_driver_compute_cluster_synthetic_simulation_try_sample_size.sh
# ==========================================================================

NUM_TRIALS=1
NUM_ITERATIONS=3

SAMPLE_SIZE_RATIO_ARRAY_SIZE=7
declare -a SAMPLE_SIZE_RATIO_ARRAY=(-1 1 5 10 25 50 75 100)


NUM_JL_TRANSFORM_TYPES=2
NUM_SPARSITY_LEVELS=2
DIM_ARRAY_SIZE=4
USE_SCRATCH_SPACE=1

COMPRESSION_RATIO_ARRAY_SIZE=5
declare -a COMPRESSION_RATIO_ARRAY=(-1 2.5 5 10 20 50)

i_sample_size=1
while [ ${i_sample_size} -le ${SAMPLE_SIZE_RATIO_ARRAY_SIZE} ];
do
	SAMPLE_SIZE_RATIO=${SAMPLE_SIZE_RATIO_ARRAY[$i_sample_size]}
	
	i_init=1
	while [ ${i_init} -le ${NUM_TRIALS} ];
	do      	
		# Seed for dictionary init
		RANDOM_SEED=${i_init} 
		i_jl_transf=1
		while [ ${i_jl_transf} -le ${NUM_JL_TRANSFORM_TYPES} ]; 
		do
			if [ “${i_jl_transf}? == “2? ]; then
				PARTIAL_FOURIER_EMBEDDDING=1
				PARTIAL_DCT_EMBEDDING=0
				PARTIAL_CIRCULANT_EMBEDDING=0
			elif [ “${i_jl_transf}? == “3? ]; then
				PARTIAL_FOURIER_EMBEDDDING=0
				PARTIAL_DCT_EMBEDDING=1
				PARTIAL_CIRCULANT_EMBEDDING=0
			elif [ “${i_jl_transf}? == “4? ]; then
				PARTIAL_FOURIER_EMBEDDDING=0
				PARTIAL_DCT_EMBEDDING=0
				PARTIAL_CIRCULANT_EMBEDDING=1		
			elif [ “${i_jl_transf}? == “1? ]; then
				PARTIAL_FOURIER_EMBEDDDING=0
				PARTIAL_DCT_EMBEDDING=0
				PARTIAL_CIRCULANT_EMBEDDING=0
			fi     
		
			i_sparsity_level=1
			while [ ${i_sparsity_level} -le ${NUM_SPARSITY_LEVELS} ]; 
			do      
				if [ “${i_sparsity_level}? == “2? ]; then
					USE_LOW_SPARSITY_LEVEL=1
					declare -a DIM_ARRAY=(-1 1024 2048 4096 8192)
				elif [ “${i_sparsity_level}? == “1? ]; then
					USE_LOW_SPARSITY_LEVEL=0
					declare -a DIM_ARRAY=(-1 512 1024 2048 4096)
				fi   							 					  								
		
				i_dim=1
				while [ ${i_dim} -le ${DIM_ARRAY_SIZE} ]; 
				do																	
					AMBIENT_DIM=${DIM_ARRAY[$i_dim]}
					INTRINSIC_DIM=${DIM_ARRAY[$i_dim]}	
			
					if [ “${i_jl_transf}? == “1? ]; then
						COMPRESSION_RATIO=0									
						qsub ictkm_driver_compute_cluster_synthetic_simulation.sge ${RANDOM_SEED} ${AMBIENT_DIM} ${INTRINSIC_DIM} ${SAMPLE_SIZE_RATIO} ${COMPRESSION_RATIO} ${USE_LOW_SPARSITY_LEVEL} ${NUM_ITERATIONS} ${PARTIAL_FOURIER_EMBEDDDING} ${PARTIAL_DCT_EMBEDDING} ${PARTIAL_CIRCULANT_EMBEDDING} ${USE_SCRATCH_SPACE}					
						#echo "RANDOM_SEED=${RANDOM_SEED} AMBIENT_DIM=${AMBIENT_DIM} INTRINSIC_DIM=${INTRINSIC_DIM} SAMPLE_SIZE_RATIO=${SAMPLE_SIZE_RATIO} COMPRESSION_RATIO=${COMPRESSION_RATIO} USE_LOW_SPARSITY_LEVEL=${USE_LOW_SPARSITY_LEVEL} NUM_ITERATIONS=${NUM_ITERATIONS} PARTIAL_FOURIER_EMBEDDDING=${PARTIAL_FOURIER_EMBEDDDING} PARTIAL_DCT_EMBEDDING=${PARTIAL_DCT_EMBEDDING} PARTIAL_CIRCULANT_EMBEDDING=${PARTIAL_CIRCULANT_EMBEDDING} USE_SCRATCH_SPACE=${USE_SCRATCH_SPACE}"								
					else
						i_compression_ratio=1
						while [ ${i_compression_ratio} -le ${COMPRESSION_RATIO_ARRAY_SIZE} ]; 
						do
							COMPRESSION_RATIO=${COMPRESSION_RATIO_ARRAY[$i_compression_ratio]}																
							qsub ictkm_driver_compute_cluster_synthetic_simulation.sge ${RANDOM_SEED} ${AMBIENT_DIM} ${INTRINSIC_DIM} ${SAMPLE_SIZE_RATIO} ${COMPRESSION_RATIO} ${USE_LOW_SPARSITY_LEVEL} ${NUM_ITERATIONS} ${PARTIAL_FOURIER_EMBEDDDING} ${PARTIAL_DCT_EMBEDDING} ${PARTIAL_CIRCULANT_EMBEDDING} ${USE_SCRATCH_SPACE}						
							#echo "RANDOM_SEED=${RANDOM_SEED} AMBIENT_DIM=${AMBIENT_DIM} INTRINSIC_DIM=${INTRINSIC_DIM} SAMPLE_SIZE_RATIO=${SAMPLE_SIZE_RATIO} COMPRESSION_RATIO=${COMPRESSION_RATIO} USE_LOW_SPARSITY_LEVEL=${USE_LOW_SPARSITY_LEVEL} NUM_ITERATIONS=${NUM_ITERATIONS} PARTIAL_FOURIER_EMBEDDDING=${PARTIAL_FOURIER_EMBEDDDING} PARTIAL_DCT_EMBEDDING=${PARTIAL_DCT_EMBEDDING} PARTIAL_CIRCULANT_EMBEDDING=${PARTIAL_CIRCULANT_EMBEDDING} USE_SCRATCH_SPACE=${USE_SCRATCH_SPACE}"
				
							i_compression_ratio=$((${i_compression_ratio}+1))
						done
					fi		
			
					i_dim=$((${i_dim}+1))											
				done
			
				i_sparsity_level=$((${i_sparsity_level}+1))
			done
		
			i_jl_transf=$((${i_jl_transf}+1))
		done	
	
		i_init=$((${i_init}+1))
	done	
	
	i_sample_size=$((${i_sample_size}+1))
done
