classdef cmd_line_progress_bar < handle
% -------------------------------------------------------------------------
% class for command-line progress-bar notification.
% Use example:
%   pb = CmdLineProgressBar('Doing stuff...');
%   for k = 1 : 10
%       pb.print(k,10)
%       % do stuff
%   end
% -------------------------------------------------------------------------

    properties
        strPercentageLength = 6;   %   Length of percentage string (must be >5)
        strDotsMaximum      = 16;   %   The total number of dots in a progress bar
        strCR = [];
    end
    methods
        %--- ctor
        function obj = cmd_line_progress_bar(msg)
            fprintf('%s', msg)
        end
        %--- print method
        function print(obj, c, tot)            
            % Progress bar - normal progress
            c = c/tot;
            %percentageOut = [' ' num2str( round(c*100) ) ' %%'];
            %percentageOut = [percentageOut repmat(' ',1,obj.strPercentageLength-length(percentageOut)-1)];
            nDots = floor(c*obj.strDotsMaximum);
            dotOut = ['\t[' repmat('.',1,nDots) repmat(' ',1,obj.strDotsMaximum-nDots) ']'];
            %strOut = [dotOut percentageOut];
            strOut = dotOut;
    
            % Print it on the screen           
            fprintf([obj.strCR strOut]);
    
            % Update carriage return
            obj.strCR = repmat('\b',1,length(strOut)-1);
            
            %--- assume user counts monotonically
            if c == tot
                fprintf('\n')
            end            
        end
        %--- dtor
        function delete(~)
            %fprintf('\n')
        end
    end
end