function results = ictkm_update_results(results, opts, dataObj, dnew)
% -------------------------------------------------------------------------
% Update IcTKM's result output structure.
% -------------------------------------------------------------------------
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compressed Dictionary Learning Toolbox
% Copyright (C) Flavio Teixeira 2018
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor,
% Boston, MA  02110-1301, USA.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
results.haltIteration = 0;

results.runTime = results.runTime + results.iterationTime;
results.timePerIter(results.iteration) = results.iterationTime;

results.avgTimePerIter = results.runTime/results.iteration;

if isa(dataObj, 'IcTKMSyntheticData')        
    rcorr = max(abs(dnew'*dataObj.dico));    
    if opts.useGPU
        rcorr = gather(rcorr);
    end
    
    results.rcorrIter(:,results.iteration) = rcorr;
    
    rec_count = find(rcorr > dataObj.recThreshold);             
    
    results.recovery_percent(results.iteration) = ...
        (length(rec_count)/opts.K)*100;
    
    results.approx_error(results.iteration) = ...
        max( sqrt( 2*(1 - rcorr) ) );
elseif isa(dataObj, 'IcTKMAudioData')
end
